package org.siforge.mvc;



import java.util.*;
import java.util.List;

import junit.framework.*;
import junit.framework.TestCase;
import junit.awtui.TestRunner;

import org.apache.log4j.Logger;

/** Leggere "JUnit Test Infected: Programmers Love Writing Tests"
 * Questa classe testa le funzionalita' evolute di OptionsList (classe in Framework)
 * Lanciare 
 * <pre>
 * 		java  junit.awtui.TestRunner org.siforge.mvc.OptionsListTest
 * </pre>
 * Oppure
 * <pre>
 * 		java  junit.textui.TestRunner  org.siforge.mvc.OptionsListTest
 * </pre>
 * 
 * 
 * @author [GG]
 * @version 1.0
 */
public class OptionsListTest extends TestCase {

  public static void main(String a[]){
    String p[]={ "org.siforge.mvc.OptionsListTest" };
    // Versione grafica:
    junit.awtui.TestRunner.main( p );
    // Versione testuale:
    //junit.textui.TestRunner.main(p);
  }
	public OptionsListTest(String s){
		super(s);
	}
	
	
	private OptionsList l, l2;
	protected void setUp() { 
		 l=new OptionsList();
		 l.addOption("a","b");
		 l.addOption("ax","bx");	
		 l.addOption("k","v");			 

		 l2=new OptionsList();
		 l2.addOption("l2a","b");
		 l2.addOption("l2ax","bx");	
		 l2.addOption("l2k","v");			 
		 		 
		 
	}
	
	public void testSimpleAdd() {		
		l.addOption("zub","cub");
        Assert.assertTrue(l.size()==4);    
    }

	public void testBADAdd() {		
		try{
			//l.add(new Object());
			ArrayList badColl=new ArrayList();
			badColl.add(new Object());
			l.add( badColl );
			super.fail("Interface BROKEN >> You cannot add objects other than OptionBean!!");
		}catch(IllegalArgumentException e){
			// Tutto ok
			// e.printStackTrace();
			super.assertTrue(true);
		}
        
    }

	public void testSimpleAccess(){
		Assert.assertTrue(l.getValue("k").equals("v"));
		Assert.assertTrue(l.getName("bx").equals("ax"));
		Assert.assertTrue( l.indexOfName("NonEsisto") == -1 );
		Assert.assertTrue( l.indexOfValue("NonEsisto") == -1 );
	}

	public void testAddRemove(){
		l.addOption("sex","bomb");
		// L;indice parte da 0, questo e' il IV elem aggiunto:
		assertTrue( l.indexOfValue("bomb") ==3);
		l.remove(l.indexOfName("sex"));
		assertTrue(l.getName("sex")==null);
	}    
	
    
    /** Testa un metodo di adding indicizzato */
    public void testAddIndexed(){
    	l.add(0, new SimpleOptionBean("www","web"));
    	assertTrue(l.indexOfName("www") == 0);
    }
    
    public void testDuplicatedKeyCheck(){
    	// Prendo il primo e provo a fare il furbetto:
		try {
			OptionBean bad=((OptionBean)l.get(l.indexOfValue("b")));
			// Ora creo un clone (non posso clonare bad direttamente perche' l'api, che e' un minimo furba, me lo vieta ;).
			l.set(2, new SimpleOptionBean(bad.getName(), bad.getValue()));
			super.fail("Duplicated KeyCheck Failed");
		} catch (IllegalArgumentException e) {
			assertTrue(true);
		}
    	
    	
    }
    	
    public void testBulkMethods(){
    	// Li metto dal secondo perche' 
    	// (index < 0 || index > size()).
    	OptionsList headList3= new OptionsList();
		headList3.addOption("l2a","b3");
		headList3.addOption("l2ax","bx3");	
		headList3.addOption("l2k","v3");
    	l.addAll(1,headList3);
    	System.out.println(l);
    	assertTrue(l.indexOfName("ax")==4);
    	l.retainAll(headList3);
    	System.out.println(l);
    	assertTrue(l.indexOfName("l2ax")==1 && l.indexOfName("l2k")==2);
    	
    }
    public static Test suite() {
    	TestSuite suite= new TestSuite();
    	suite.addTest(new OptionsListTest("testSimpleAdd"));   
    	suite.addTest(new OptionsListTest("testSimpleAccess"));  
    	suite.addTest(new OptionsListTest("testAddRemove"));
    	suite.addTest(new OptionsListTest("testBulkMethods"));
    	suite.addTest(new OptionsListTest("testAddIndexed"));
    	suite.addTest(new OptionsListTest("testBADAdd"));
    	suite.addTest(new OptionsListTest("testDuplicatedKeyCheck"));
    	return suite;
	}

}